diff mbox

[v2,8/8] overlay: accessing stacked overlayfs files

Message ID 1487306188-2097-8-git-send-email-xzhou@redhat.com (mailing list archive)
State New, archived
Headers show

Commit Message

Murphy Zhou Feb. 17, 2017, 4:36 a.m. UTC
Lower dir comes from another overlayfs dir, then
accessing files in it should work.

CC: Miklos Szeredi <mszeredi@redhat.com>
Signed-off-by: Xiong Zhou <xzhou@redhat.com>
---
 tests/overlay/029     | 100 ++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/overlay/029.out |   5 +++
 tests/overlay/group   |   1 +
 3 files changed, 106 insertions(+)
 create mode 100755 tests/overlay/029
 create mode 100644 tests/overlay/029.out

Comments

Amir Goldstein Feb. 17, 2017, 7:16 a.m. UTC | #1
On Fri, Feb 17, 2017 at 6:36 AM, Xiong Zhou <xzhou@redhat.com> wrote:
> Lower dir comes from another overlayfs dir, then
> accessing files in it should work.
>
> CC: Miklos Szeredi <mszeredi@redhat.com>
> Signed-off-by: Xiong Zhou <xzhou@redhat.com>
> ---
>  tests/overlay/029     | 100 ++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/overlay/029.out |   5 +++
>  tests/overlay/group   |   1 +
>  3 files changed, 106 insertions(+)
>  create mode 100755 tests/overlay/029
>  create mode 100644 tests/overlay/029.out
>
> diff --git a/tests/overlay/029 b/tests/overlay/029
> new file mode 100755
> index 0000000..3909155
> --- /dev/null
> +++ b/tests/overlay/029
> @@ -0,0 +1,100 @@
> +#! /bin/bash
> +# FS QA Test 029
> +#
> +# There are dirs/files in lower dir and upper dir before
> +# mounting overlayfs. After mounting, use dir in overlayfs
> +# mountpoint as lowerdir to mount another overlayfs, then
> +# access old files through the second overlayfs. It was
> +# not working, kernel commit below fixed it.
> +#
> +# c4fcfc1619ea ovl: fix d_real() for stacked fs
> +#
> +# This reproducer was originally written by
> +#     Miklos Szeredi <mszeredi@redhat.com>
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2017 Red Hat Inc.  All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
> +#-----------------------------------------------------------------------
> +#
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1       # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +       cd /
> +       $UMOUNT_PROG $tmp/mnt
> +       rm -rf $tmp/{upper,mnt,work}
rm -rf $tmp (which test has created)
> +       rm -f $tmp.*
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# remove previous $seqres.full before test
> +rm -f $seqres.full
> +
> +# real QA test starts here
> +
> +# Modify as appropriate.
> +_supported_fs overlay
> +_supported_os Linux
> +_require_scratch
> +
> +# Remove all files from previous tests
> +_scratch_mkfs
> +
> +# Preparing files
> +upperdir=$SCRATCH_DEV/$OVERLAY_UPPER_DIR
> +lowerdir=$SCRATCH_DEV/$OVERLAY_LOWER_DIR
> +mkdir -p $upperdir/up
> +echo foo > $upperdir/up/foo
> +mkdir -p $lowerdir/low
> +echo bar > $lowerdir/low/bar
> +
> +# mount overlay in SCRATCH_MNT
> +_scratch_mount
> +
> +mkdir -p $tmp/{upper,mnt,work}
> +# mount overlay again using upper dir from SCRATCH_MNT dir
> +_overlay_mount_dirs $SCRATCH_MNT/up $tmp/{upper,work} \
> +  overlay $tmp/mnt
> +# accessing file in the second mount
> +cat $tmp/mnt/foo
> +$UMOUNT_PROG $tmp/mnt
> +
> +# mount overlay again using lower dir from SCRATCH_MNT dir
> +_overlay_mount_dirs $SCRATCH_MNT/low $tmp/{upper,work} \
> +  overlay $tmp/mnt
> +cat $tmp/mnt/bar
> +$UMOUNT_PROG $tmp/mnt
> +
> +# mount overlay again using SCRATCH_MNT dir
> +_overlay_mount_dirs $SCRATCH_MNT/ $tmp/{upper,work} \
> +  overlay $tmp/mnt
> +cat $tmp/mnt/up/foo
> +cat $tmp/mnt/low/bar
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/overlay/029.out b/tests/overlay/029.out
> new file mode 100644
> index 0000000..e7f192c
> --- /dev/null
> +++ b/tests/overlay/029.out
> @@ -0,0 +1,5 @@
> +QA output created by 029
> +foo
> +bar
> +foo
> +bar
> diff --git a/tests/overlay/group b/tests/overlay/group
> index cf058fc..7e72a30 100644
> --- a/tests/overlay/group
> +++ b/tests/overlay/group
> @@ -31,3 +31,4 @@
>  026 auto attr quick
>  027 auto quick perms
>  028 auto copyup quick
> +029 auto quick
> --
> 1.8.3.1
>
> --
> To unsubscribe from this list: send the line "unsubscribe fstests" in
> the body of a message to majordomo@vger.kernel.org
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/tests/overlay/029 b/tests/overlay/029
new file mode 100755
index 0000000..3909155
--- /dev/null
+++ b/tests/overlay/029
@@ -0,0 +1,100 @@ 
+#! /bin/bash
+# FS QA Test 029
+#
+# There are dirs/files in lower dir and upper dir before
+# mounting overlayfs. After mounting, use dir in overlayfs
+# mountpoint as lowerdir to mount another overlayfs, then
+# access old files through the second overlayfs. It was
+# not working, kernel commit below fixed it.
+#
+# c4fcfc1619ea ovl: fix d_real() for stacked fs
+#
+# This reproducer was originally written by
+#     Miklos Szeredi <mszeredi@redhat.com>
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Red Hat Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	$UMOUNT_PROG $tmp/mnt
+	rm -rf $tmp/{upper,mnt,work}
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs overlay
+_supported_os Linux
+_require_scratch
+
+# Remove all files from previous tests
+_scratch_mkfs
+
+# Preparing files
+upperdir=$SCRATCH_DEV/$OVERLAY_UPPER_DIR
+lowerdir=$SCRATCH_DEV/$OVERLAY_LOWER_DIR
+mkdir -p $upperdir/up
+echo foo > $upperdir/up/foo
+mkdir -p $lowerdir/low
+echo bar > $lowerdir/low/bar
+
+# mount overlay in SCRATCH_MNT
+_scratch_mount
+
+mkdir -p $tmp/{upper,mnt,work}
+# mount overlay again using upper dir from SCRATCH_MNT dir
+_overlay_mount_dirs $SCRATCH_MNT/up $tmp/{upper,work} \
+  overlay $tmp/mnt
+# accessing file in the second mount
+cat $tmp/mnt/foo
+$UMOUNT_PROG $tmp/mnt
+
+# mount overlay again using lower dir from SCRATCH_MNT dir
+_overlay_mount_dirs $SCRATCH_MNT/low $tmp/{upper,work} \
+  overlay $tmp/mnt
+cat $tmp/mnt/bar
+$UMOUNT_PROG $tmp/mnt
+
+# mount overlay again using SCRATCH_MNT dir
+_overlay_mount_dirs $SCRATCH_MNT/ $tmp/{upper,work} \
+  overlay $tmp/mnt
+cat $tmp/mnt/up/foo
+cat $tmp/mnt/low/bar
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/029.out b/tests/overlay/029.out
new file mode 100644
index 0000000..e7f192c
--- /dev/null
+++ b/tests/overlay/029.out
@@ -0,0 +1,5 @@ 
+QA output created by 029
+foo
+bar
+foo
+bar
diff --git a/tests/overlay/group b/tests/overlay/group
index cf058fc..7e72a30 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -31,3 +31,4 @@ 
 026 auto attr quick
 027 auto quick perms
 028 auto copyup quick
+029 auto quick